#!/bin/sh

if [ -z "$1" ] || [ -z "$2" ]; then
    echo -e "Usage:\t$0 <user> <server> <optional: path>"
    exit 1
fi

usr=$1
srv=$2
path=""

if [ -n "$3" ]; then
    path="/"$3
fi

root="/root/armagetronad"
lookin=$root"/users/"$usr"/servers/"$srv""$path

#   easier but akward method
#find $lookin -maxdepth 1 -type f
#find $lookin -maxdepth 1 -type d

result=$($root/manage/path_exists.sh $usr $srv $3)
echo $result

#   a different approch
for file in $lookin/*
do
    if [ -f $file ]; then
        #echo "FILE: "$file
        a=$file
        b=$(basename $a)
        echo "FILE: "$b
    elif [ -d $file ]; then
        #echo "DIR: "$file
        a=$file
        b=$(basename $a)
        echo "DIR: "$b
    fi
done