#!/bin/bash

usr=$2
srv=$3
root="/root/armagetronad"
wit=$root"/manage/"

loc=$root"/users/"$usr"/servers/"$srv"/"
cmd=$loc"command.txt"

case $1 in
    start)
        if ! screen -list | grep -q $usr"_"$srv; then
            echo "Starting "$srv" server immediately."
            screen -dmS $usr"_"$srv $wit"server.sh" $usr $srv
        else
            echo "Server \""$srv"\" is already running."
        fi
        ;;
    stop)
        if ! screen -list | grep -q $usr"_"$srv; then
            echo "Server \""$srv"\" is already stopped."
        else
            echo "Stopping "$srv" server immediately."
            echo "EXIT" >> $cmd
            sleep 1
            screen -S $usr"_"$srv -X quit
        fi
        ;;
esac