<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

function browseExecute()
{
    global $COMMON;
    
    switch (Filter(@$_REQUEST['mode']))
    {
        case 'view':
            $dir_contents = array('DIRECTORY_EXISTS', 'FILE: commands.txt', 'DIR: etc');
            $path = @$_REQUEST['path'];
            
            if ($COMMON->ssh->connected())
            {
                $line = $COMMON->server_manager."list_files.sh ".$COMMON->data->usr->name." ".$COMMON->data->srv->name.((Filter($path) != "")?" ".$path:"");
                if ($stream = $COMMON->ssh->exec($line))
                {
                    stream_set_blocking($stream, true);
                    
                    $message = trim(htmlentities(stream_get_contents($stream)));
                    $dir_contents = explode("\n", $message);
                }
            }
            
            if (endswith(Filter(@$dir_contents[0]), "_exists"))
            {
                if (startswith(Filter(@$dir_contents[0]), "file"))  //  if the path is a file
                {
                    $file = $path;
                    $dir  = dirname($path);
                    
                    if ($dir == ".") $dir = "";
                    
                    $pathinfo = pathinfo(basename($file));
                    if (!in_array($pathinfo['extension'], $COMMON->browse_extensions))
                    {
                        loadHeaders();
                        ?>
                        <a style="text-decoration: none; color: #77ff22; float: left;" href="<?php echo $COMMON->url; ?>?area=browse&mode=view&path=<?php echo $dir; ?>"><img title="Back" src="<?php echo $COMMON->url; ?>/images/file_folder/back.png" /></a>
                        
                        <center>
                            <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                                Extension <?php echo $pathinfo['extension']; ?> for file "<?php echo $file; ?>" is not  allowed.
                            </div>
                        </center>
                        <?php
                        return;
                    }
                    
                    if (!page_blocked($path))
                    {
                        $remote_file = $COMMON->path_server_root."/".$file;
                        $local_file  = $COMMON->local_server_path."/".$file;
                        createLocalFolders($dir);
                        
                        if ($COMMON->ssh->connected())
                        {
                            if ($COMMON->ssh->download_file($remote_file, $local_file))
                            {
                                loadHeaders();
                                
                                ?>
                                <center>
                                    <div style="width: 70%; text-align: left;">
                                        <div style="background: #ffff7f; color: #990099; padding: 10px; text-align: center;"><a style="text-decoration: none; color: #77ff22; float: left;" href="<?php echo $COMMON->url; ?>?area=browse&mode=view&path=<?php echo $dir; ?>"><img title="Back" src="<?php echo $COMMON->url; ?>/images/file_folder/back.png" /></a><b><?php echo basename($local_file); ?></b><a style="float: right" href="<?php echo $COMMON->url; ?>?area=browse&mode=remove&path=<?php echo $path; ?>"><img title="Delete" src="<?php echo $COMMON->url; ?>/images/editor/delete.png" /></a><a style="float: right" href="<?php echo $COMMON->url; ?>?area=browse&mode=edit&path=<?php echo $path; ?>"><img title="Edit" src="<?php echo $COMMON->url; ?>/images/editor/edit.png" /></a></div>
                                        <div style="background: #ffffaa; font-size: 13px; padding: 5px; border: 1px groove #ffffff; word-wrap: break-word; word-break: break-all; white-space: pre; display: block; font-family: monospace;"><?php echo htmlentities(file_get_contents($local_file)); ?></div>
                                    </div>
                                </center>
                                <?php
                            }
                            else
                            {
                                loadHeaders();
                                ?>
                                <center>
                                    <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                                        Couldn't load the file "<?php echo $file; ?>" ...
                                    </div>
                                </center>
                                <?php
                            }
                        }
                        else
                        {
                            loadHeaders();
                            ?>
                            <center>
                                <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                                    Couldn't load the file "<?php echo $file; ?>" ...
                                </div>
                            </center>
                            <?php
                        }
                    }
                    else
                    {
                        loadHeaders();
                        ?>
                        <center>
                            <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                                Path "<?php echo $file; ?>" is blocked from access...
                            </div>
                        </center>
                        <?php
                    }
                }
                else
                {
                    loadHeaders();
                    ?>
                    <center>
                        <table style="background: rgba(50, 0, 10, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                        <?php
                        $prev_dir = dirname($path);
                        if ($prev_dir == ".") $prev_dir = "";
                        ?>
                            <tr>
                                <td align="left">
                                    <a style="text-decoration: none; color: #77ff22;" href="<?php echo $COMMON->url; ?>?area=browse&mode=view&path=<?php echo $prev_dir; ?>">
                                    <?php
                                    if ($path != "")
                                    {
                                    ?>
                                        <img title="Back" src="<?php echo $COMMON->url; ?>/images/file_folder/back.png" />
                                    <?php
                                    }
                                    ?>
                                    </a>
                                </td>
                                <td width="1%">
                                    <a style="text-decoration: none; color: #77ff22;" href="<?php echo $COMMON->url; ?>?area=browse&mode=create&type=file&path=<?php echo $path; ?>"><img title="New File" src="<?php echo $COMMON->url; ?>/images/editor/new.png" /></a>
                                </td>
                                <td width="1%">
                                    <a style="text-decoration: none; color: #77ff22;" href="<?php echo $COMMON->url; ?>?area=browse&mode=create&type=folder&path=<?php echo $path; ?>"><img title="New Folder" src="<?php echo $COMMON->url; ?>/images/editor/new_folder.png" /></a>
                                </td>
                            </tr>
                        </table>
                        
                        <table style="background: rgba(50, 0, 10, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                        <?php
                        
                        for ($i = 1; $i < count($dir_contents); $i++)
                        {
                            if (!page_blocked($dir_contents[$i]))
                            {
                            ?>
                            <tr>
                                <?php
                                if (startswith($dir_contents[$i], "DIR: ")) //  this is a directory
                                {
                                    $d = substr($dir_contents[$i], 5);
                                ?>
                                <td width="50px"><img src="<?php echo $COMMON->url; ?>/images/file_folder/folder.png" /></td>
                                <td><a class="browse_links" href="<?php echo $COMMON->url; ?>?area=browse&mode=view&path=<?php echo (($path != "")?$path."/":"").$d; ?>"><?php echo $d; ?></a></td>
                                    <?php
                                }
                                elseif (startswith($dir_contents[$i], "FILE: "))    //  this is a file
                                {
                                    $f = substr($dir_contents[$i], 6);
                                    $pathinfo = pathinfo($f);
                                    if (in_array($pathinfo['extension'], $COMMON->browse_extensions))
                                    {
                                ?>
                                <td style="width: 1%;"><img src="<?php echo $COMMON->url; ?>/images/file_folder/<?php echo $COMMON->browse_ext_images[$pathinfo['extension']]; ?>" /></td>
                                <td><a class="browse_links" href="<?php echo $COMMON->url; ?>?area=browse&mode=view&path=<?php echo (($path != "")?$path."/":"").$f; ?>"><?php echo $f; ?></a></td>
                                <td align="right" style="width:10%;"><a href="<?php echo $COMMON->url; ?>?area=browse&mode=edit&path=<?php echo (($path != "")?$path."/":"").$f; ?>"><img title="Edit" src="<?php echo $COMMON->url; ?>/images/editor/edit.png" /></a><a href="<?php echo $COMMON->url; ?>?area=browse&mode=remove&path=<?php echo (($path != "")?$path."/":"").$f; ?>"><img title="Delete" src="<?php echo $COMMON->url; ?>/images/editor/delete.png" /></a></td>
                                    <?php
                                    }
                                }
                                ?>
                            </tr>
                            <?php
                            }
                        }
                        ?>
                        </table>
                    </center>
                    <?php
                }
            }
            else
            {
                loadHeaders();
                ?>
                <center>
                    <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                        Unknown error detected while execution... <?php echo @$dir_contents[0]; ?>
                    </div>
                </center>
                <?php
            }
            break;
        
        case 'edit':
            $path = @$_REQUEST['path'];
            
            $message = "";
            if ($COMMON->ssh->connected())
            {
                $line = $COMMON->server_manager."path_exists.sh ".$COMMON->data->usr->name." ".$COMMON->data->srv->name.((Filter($path) != "")?" ".$path:"");
                if ($stream = $COMMON->ssh->exec($line))
                {
                    stream_set_blocking($stream, true);
                    
                    $message = trim(htmlentities(stream_get_contents($stream)));
                }
            }
            
            if (Filter($message) == "file_exists")
            {
                $file = $path;
                $dir  = dirname($path);
                
                if ($dir == ".") $dir = "";
                
                $pathinfo = pathinfo(basename($file));
                if (!in_array($pathinfo['extension'], $COMMON->browse_extensions))
                {
                    loadHeaders();
                    ?>                    
                    <center>
                        <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                            Extensions <?php echo $pathinfo['extension']; ?> for file "<?php echo $file; ?>" is not  allowed.
                        </div>
                    </center>
                    <?php
                    return;
                }
                
                if (!page_blocked($path))
                {
                    $remote_file = $COMMON->path_server_root."/".$file;
                    $local_file  = $COMMON->local_server_path."/".$file;
                    createLocalFolders($dir);
                    
                    if ($COMMON->ssh->connected())
                    {
                        if ($COMMON->ssh->download_file($remote_file, $local_file))
                        {
                            loadHeaders();
                            show_stats();
                            ?>
                            <center>
                                <div style="width: 70%; text-align: left;">
                                    <form action="" method="post">
                                        <div style="background: #ffff7f; color: #990099; padding: 10px; text-align: center;">
                                            <a style="text-decoration: none; color: #77ff22; float: left;" href="<?php echo $COMMON->url; ?>?area=browse&mode=view&path=<?php echo $dir; ?>">
                                                <img title="Back" src="<?php echo $COMMON->url; ?>/images/file_folder/back.png" />
                                            </a>
                                            <b><?php echo basename($local_file); ?></b>
                                            <button name="browse_file_save" title="Save" style="background: none; border: none; padding: 0px; float: right; cursor: pointer;" type="submit"><img title="Save" src="<?php echo $COMMON->url; ?>/images/editor/save.png" /></button>
                                        </div>
                                        <textarea name="file_content" style="background: #ffffaa; padding: 5px; font-size: 13px; width: 100%; height: 100%;"><?php echo file_get_contents($local_file); ?></textarea>
                                    </form>
                                </div>
                            </center>
                            <?php
                        }
                        else
                        {
                            loadHeaders();
                            ?>
                            <center>
                                <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                                    Couldn't load the file "<?php echo $file; ?>" ...
                                </div>
                            </center>
                            <?php
                        }
                    }
                    else
                    {
                        loadHeaders();
                        ?>
                        <center>
                            <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                                Couldn't load the file "<?php echo $file; ?>" ...
                            </div>
                        </center>
                        <?php
                    }
                }
                else
                {
                    loadHeaders();
                    ?>
                    <center>
                        <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                            Path "<?php echo $file; ?>" is blocked from access...
                        </div>
                    </center>
                    <?php
                }
            }
            else
            {
                loadHeaders();
                ?>
                <center>
                    <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                        Expecting FILE_EXISTS, received "<?php echo $message; ?>" for <?php echo $path; ?>.
                    </div>
                </center>
                <?php
            }
            break;
        
        case "remove":
            $path = @$_REQUEST['path'];
            $file = $path;
            
            if (Filter($path) !== "")
            {
                $pathinfo = pathinfo(basename($file));
                if (!in_array($pathinfo['extension'], $COMMON->browse_extensions))
                {
                    loadHeaders();
                    ?>                    
                    <center>
                        <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                            Extensions <?php echo $pathinfo['extension']; ?> for file "<?php echo $file; ?>" is not  allowed.
                        </div>
                    </center>
                    <?php
                    return;
                }
                
                if (!page_blocked($path))
                {
                    loadHeaders();
                    ?>                    
                    <center>
                        <div style="background: #990099; color: #00ffff; padding: 5px; width: 50%;">
                            Under construction...
                        </div>
                    </center>
                    <?php
                }
                else
                {
                    loadHeaders();
                    ?>
                    <center>
                        <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                            Path "<?php echo $file; ?>" is blocked from access...
                        </div>
                    </center>
                    <?php
                }
            }
            else
            {
                loadHeaders();
                ?>
                <center>
                    <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                        Path cannot be empty to remove.
                    </div>
                </center>
                <?php
            }
            break;
        
        case "create":
            switch(Filter(@$_REQUEST['type']))
            {
                case "file":
                    loadHeaders();
                    ?>                    
                    <center>
                        <div style="background: #990099; color: #00ffff; padding: 5px; width: 50%;">
                            Under construction...
                        </div>
                    </center>
                    <?php
                    break;
                
                case "folder":
                    loadHeaders();
                    ?>                    
                    <center>
                        <div style="background: #990099; color: #00ffff; padding: 5px; width: 50%;">
                            Under construction...
                        </div>
                    </center>
                    <?php
                    break;
                
                default:
                    loadHeaders();
                    ?>
                    <center>
                        <div style="background: rgba(0, 0, 255, 0.75); color: #f9f9f9; width: 50%; padding: 5px; text-align: left;">
                            Must specify what type to create...
                        </div>
                    </center>
                    <?php
                    break;
            }
            break;
        
        default:
            header("Location: ".$COMMON->url."?area=browse&mode=view");
            break;
    }
}

function page_blocked($page)
{
    global $COMMON;
    
    if (startswith($page, "DIR: ")) //  this is a directory
    {
        $page = substr($page, 5);
    }
    elseif (startswith($page, "FILE: "))    //  this is a file
    {
        $page = substr($page, 6);
    }
    
    foreach ($COMMON->browse_blackpages as $pg)
    {
        if (Filter($pg) == stripslashes(Filter($page)))
            return true;
    }
    
    return false;
}
?>