<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

function loadHeaders()
{
    global $COMMON;
?>
<html>
    <head>
        <title>Armagetron Advanced Web Interface</title>
        <link type="text/css" href="<?php echo $COMMON->url; ?>style.css" rel="stylesheet"/>
        <link rel="shortcut icon" href="<?php echo $COMMON->url; ?>images/favicon.ico" />
        <link rel="icon" type="image/png" href="<?php echo $COMMON->url; ?>images/favicon.png" />
    </head>
    <body>
        <div class="header">
            <h1 style="text-align: center;">Armagetron Advanced Web Interface</h1>
            <?php navigationLinks(); ?>
        </div>
<?php
    //  display the messages as the headers have loaded
    if (count($COMMON->messages) > 0)
    {
        foreach ($COMMON->messages as $msg)
        {
            echo $msg."\n";
        }
    }
}

function loadCommandCenter()
{
    global $COMMON;
    ?>
        <form action="" method="post">
            <div>
                <div style="float: left; width: 50%;">
                    <!-- SERVER NAME BEGIN -->
                    <div class="form_area">
                        <h3 style="text-align: center;">Server Name</h3>
                        <label class="input_commandstruct" name="server"><?php echo $COMMON->data->srv->name; ?></label>
                    </div>
                    <!-- SERVER NAME END -->
                    <br />
                    <!-- SERVER COMMAND BEGIN -->
                    <div class="form_area">
                        <h3 style="text-align: center;">Console Command Execute</h3>
                        SERVER COMMAND:
                        <br />
                        <input class="input_commandline" name="input_command" list="commands_list" type="text" style="width: 90%;"/>
                        <datalist id="commands_list">
                        <?php
                        foreach (Command::$commands as $cmd)
                        {
                            ?>
                            <option value="<?php echo trim($cmd->name); ?>"><?php echo trim($cmd->name); ?></option>
                            <?php
                        }
                        ?>
                        </datalist>
                        <input class="input_buttonexec" name="server-command" type="submit" value="SEND" />
                    </div>
                    <!-- SERVER COMMAND END -->
                    <br />
                    <!-- SERVER MANAGEMENT BEGIN -->
                    <div class="form_area">
                        <h3 style="text-align: center;">Server Management</h3>
                        <input class="input_buttonexec" name="server-start" type="submit" value="START" />
                        <input class="input_buttonexec" name="server-stop" type="submit" value="STOP" />
                        <label class="status" style="<?php echo ($COMMON->data->srv->online)?"color: #66ff77;":"color: #ff7777; " ?>float: right"><?php echo ($COMMON->data->srv->online)?"ONLINE":"OFFLINE"; ?></label>
                    </div>
                    <!-- SERVER MANAGEMENT END -->
                </div>
                <div style="float: right; text-align: left; width: 50%;">
                    <form action="" method="post">
                        <div class="status" style="color: #9999ff;">Input Log: <?php echo $COMMON->data->srv->name; ?><input style="float: right; padding: 0px 5px;" type="submit" name="clear-input" value="Clear" /></div>
                    </form>
                    <pre style="background-color: rgba(0, 0, 0, 0.57); color: #ffffff; overflow: auto; height: 39%; font-size: 13px;"><?php echo $COMMON->data->srv->input_log; ?></pre>
                </div>
            </div>
        </form>
        
        <table width="100%"><tr><td></td></tr></table>
        
        <form action="" method="post">
            <div class="status" style="color: #9999ff;">Console Log: <?php echo $COMMON->data->srv->name; ?><input style="float: right; padding: 0px 5px;" type="submit" name="clear-console" value="Clear" /></div>
        </form>
        <div style="background-color: rgba(255, 255, 255, 0.57); text-align: left; font-size: 13px; color: #f9f9f9; overflow: auto; height: 76%;">
            <pre style="background: none; border: 0px;"><?php echo $COMMON->data->srv->console_log; ?></pre>
        </div>
    <?php
}

function navigationLinks()
{
    global $COMMON;
    ?>
        <center>
            <a class="links_display<?php echo (($COMMON->area == "home") || ($COMMON->area == ""))?" links_display_sel":""; ?>" href="<?php echo $COMMON->url; ?>?area=home"><span style="">Home</span></a>
            <?php
            if (isset($COMMON->data->usr) && isset($COMMON->data->srv))
            {
            ?>
            <a class="links_display<?php echo ($COMMON->area == "execute")?" links_display_sel":""; ?>" href="<?php echo $COMMON->url; ?>?area=execute"><span style="">Execute</span></a>
            <a class="links_display<?php echo ($COMMON->area == "servers")?" links_display_sel":""; ?>" href="<?php echo $COMMON->url; ?>?area=servers"><span style="">Servers</span></a>
            <a class="links_display<?php echo ($COMMON->area == "browse")?" links_display_sel":""; ?>" href="<?php echo $COMMON->url; ?>?area=browse"><span style="">Browse</span></a>
            <?php
            }
            ?>
            <a class="links_display<?php echo ($COMMON->area == "contact")?" links_display_sel":""; ?>" href="<?php echo $COMMON->url; ?>?area=contact"><span style="">Contact</span></a>
            <a class="links_display<?php echo ($COMMON->area == "commands")?" links_display_sel":""; ?>" href="<?php echo $COMMON->url; ?>?area=commands"><span style="">Commands</span></a>
            <?php
            if (isset($COMMON->data->usr) && isset($COMMON->data->srv))
            {
            ?>
            <a class="links_display<?php echo ($COMMON->area == "logout")?" links_display_sel":""; ?>" href="<?php echo $COMMON->url; ?>?area=logout"><span style="">Logout</span></a>
            <?php
            }
            ?>
        </center>
    <?php
}

function loadHome()
{
    global $COMMON;
    
    ?>
    <center>
        <table style="background: #FEFEFE; width: 50%;">
            <tr>
                <td style="background: #9999ff; padding: 10px 10px 10px 0px;">
                    <span style="padding: 10px; background: #ff0099; width: 100%;">Username: </span><span style="padding: 10px;"><?php echo $COMMON->data->usr->name; ?></span>
                </td>
            </tr>
            <tr>
                <td style="background: #9999ff; padding: 10px 10px 10px 0px;">
                    <span style="padding: 10px; background: #ff0099; width: 100%;">Servers: </span><span style="padding: 10px;"><?php echo $COMMON->data->usr->servers; ?></span>
                </td>
            </tr>
        </table>
    </center>
    <?php
}

function footer()
{
    global $COMMON;
    
    $COMMON->sql->close();
    
    ?>
        <div class="footer">
            <h2 style="text-align: center;"> Armagetron Advanced<br />Alpha Project</h2>
        </div>
    <?php
}

function errorMessage($message, $show = true, $store = false)
{
    global $COMMON;
    
    if ($show)
        loadHeaders();
    
    if ($store)
    {
        $COMMON->messages[] = '<div class="error" style="text-align: center;">'.$message.'</div>';
    }
    else
    {
    ?>
    <div class="error" style="text-align: center;"><?php echo $message; ?></div>
    <?php
    }
    
    if ($show)
        footer();
}

function statusMessage($msg, $status = false)
{
    global $COMMON;
    
    $COMMON->stat_msgs[] = new StatusMsg($msg, $status);
}

function show_stats()
{
    global $COMMON;
    
    if (count($COMMON->stat_msgs) > 0)
    {
        ?>
        <span style="padding: 5px; line-height: 30px; background: #333333; color: #ff99ff; border: 1px solid #555555;">Status:</span>
        <div class="status">
            <?php
            foreach ($COMMON->stat_msgs as $key => $msg)
            {
                if ($msg instanceof StatusMsg)
                {
                    ?>
                    <span <?php (($msg->Status())?print('style="color: #66ff77;"'):''); ?>><?php echo $msg; ?></span>
                    <?php
                    
                    if (($key + 1) < count($COMMON->stat_msgs))
                    {
                        ?>
                        <br />
                        <?php
                    }
                }
            }
            ?>
        </div>
        <?php
    }
}

function createLocalFolders($addon_path = "")
{
    global $COMMON;
    
    $ext = explode("/", $COMMON->local_server_path.(($addon_path != "")?"/".$addon_path:""));
    $bld = "";
    foreach ($ext as $key => $dir)
    {
        if ($bld .= $dir."/")
        {
            if (!is_dir($bld))
            {
                mkdir($bld);
                chmod($bld, 0777);
            }
        }
    }
}

function WrongPage()
{
    header('Status: ' . 404, true, 404);
    
    loadHeaders();
    ?>
    <center>
        <div style="background: #1a1a1a; color: #5f5f5f; font-family: 'TR2N'; font-size: 150px;">
            404<br />
            Guess what<br />
            ...<br />
            Wrong page!
        </div>
    </center>
    <?php
}
?>