#!/bin/bash

if [ -z "$1" ] || [ -z "$2" ]; then
    echo -e "Usage:\t$0 <user> <server> <optional: path>"
    exit 1
fi

usr=$1
srv=$2
path=""

if [ -n "$3" ]; then
    path="/"$3
fi

root="/root/armagetronad"
lookin=$root"/users/"$usr"/servers/"$srv""$path

if [[ -d $lookin ]]; then
    echo "DIRECTORY_EXISTS"
elif [[ -f $lookin ]]; then
    echo "FILE_EXISTS"
else
    echo "DOES_NOT_EXIST"
fi