<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

error_reporting(E_ALL);
ini_set('display_errors', '1');

$path_to_server = "/root/armagetronad";
$path_to_script = dirname(__FILE__);

require $path_to_script."/src/string.php";
require $path_to_script."/src/common.php";
require $path_to_script."/src/commands.php";
require $path_to_script."/src/execute.php";
require $path_to_script."/src/functions.php";
require $path_to_script."/src/login.php";
require $path_to_script."/src/server.php";
require $path_to_script."/src/ssh.php";
require $path_to_script."/src/sql.php";
require $path_to_script."/src/browse.php";

session_start();
session_cache_expire(0);

$COMMON = new Common();
$COMMON->path_server_loc    = $path_to_server;
$COMMON->path_server_root   = $COMMON->path_server_loc."/users/".'$1'."/servers/".'$2';

$COMMON->server_manager     = $COMMON->path_server_loc."/manage/";
$COMMON->path_server_script = $COMMON->server_manager."start.sh";

$COMMON->area = Filter(@$_REQUEST['area']);
$COMMON->root = $path_to_script;

$COMMON->whitepages = array('contact', 'commands');

$COMMON->browse_blackpages = array
                                (
                                    'bin',
                                    'bin/armagetronad-dedicated'
                                );

$COMMON->browse_extensions = array('php', 'html', 'txt', 'xml', 'log', 'cfg');

$COMMON->browse_ext_images = array
                                (
                                    'php' => 'php.png',
                                    'html' => 'html.png',
                                    'txt' => 'file.png',
                                    'log' => 'file.png',
                                    'cfg' => 'cfg.png'
                                );

//  the url ROOT address of this website
$COMMON->url  = "http://127.0.0.1/projects/web_interface/";

//  connect to the sql server and establish database link
$COMMON->sql = new SQL("root", "", "tron_manager");

//  initialize the list of commands into an static array
Command::init();

$pass = false;
if (in_array($COMMON->area, $COMMON->whitepages))
    $pass = true;

//  ensure user is logged in before continuing
if (!checkLogin(($pass)?false:true))
{
    if (!$pass)
        die();
}

//  connect to the VPS server through SSH Access Method
$COMMON->ssh = new SSH("person.8ing.com");
if (!$COMMON->ssh->login("root", "antserve"))
{
    errorMessage("Unable to connect to SSH server.", false, true);
}

//  executing internal services
if (!$pass)
    executeService();
?>