<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

//  the process for executing the command to server file
function executeManager()
{
    global $COMMON;
    
    loadHeaders();
    show_stats();
    loadCommandCenter();
}


//  checking all executions
function executeService()
{
    global $COMMON;
    
    $process = false;
    
    //  check if server is online or offline
    check_sever_status();
    
    //  start the server
    if (isset($_POST['server-start']))
    {
        startServer();
        $process = true;
        
        check_sever_status();
    }
    
    //  stop the server
    if (isset($_POST['server-stop']))
    {
        stopServer();
        $process = true;
        
        check_sever_status();
    }
    
    //  execute the server command
    if (isset($_POST['server-command']))
    {
        $command = $value = "";
        if (Filter($_POST['input_command']) !== "")
        {
            $pos = 0;
            $command = Filter(extractNonBlankString($_POST["input_command"], $pos), false);
            $value   = trim(substr($_POST['input_command'], $pos + 1));
            
            if (Command::checkCommand($command))
            {
                if (!sendCommand($command, $value))
                {
                    statusMessage("Command \"".strtoupper($command)." ".$value."\" couldn't be sent.\n");
                }
                else
                {
                    statusMessage("Command \"".strtoupper($command)." ".$value."\" has been sent.\n", true);
                }
                
                $process = true;
            }
            else
            {
                statusMessage("Command \"".strtoupper($command)."\" doesn't exist.\n");
            }
        }
    }
    
    //  clearing of console log
    if (isset($_POST['clear-console']))
    {
        if (clearConsoleLog())
        {
            statusMessage("Cleared console log successfully.", true);
        }
        else
        {
            statusMessage("Couldn't clear console log.");
        }
        
        $process = true;
    }
    
    //  clearing of input log
    if (isset($_POST['clear-input']))
    {
        if (!$COMMON->data->srv->online)
        {
            if (clearInputLog())
            {
                statusMessage("Cleared input log successfully.", true);
            }
            else
            {
                statusMessage("Couldn't clear input log.");
            }
        }
        else
        {
            statusMessage("Couldn't clear input log while server is active.");
        }
        
        $process = true;
    }
    
    //  saving browsing file
    if (isset($_POST['browse_file_save']))
    {
        $path = $_REQUEST['path'];
        
        $remote_file = $COMMON->path_server_root."/".$path;
        $local_file  = $COMMON->local_server_path."/".$path;
        
        file_put_contents($local_file, $_POST['file_content']);
        
        if ($COMMON->ssh->connected())
        {
            if ($COMMON->ssh->upload_file($local_file, $remote_file))
            {
                statusMessage("Successfully saved ".basename($local_file).".", true);
            }
            else
            {
                statusMessage(basename($local_file)." failed to save due to unknown reasons.");
            }
        }
    }
    
    if ($process) sleep(2);
    
    //  with the information for the server get its current status details
    checkServer();
}
?>