<?php
##################################################################
######           ARMAGETRON ADVANCED WEB INTERFACE          ######
##################################################################
######  Script by: LOVER$BOY                                ######
######  Version: 1.0                                        ######
######  Description: Please leave this header. Thanks!      ######
######  Contact: zodiacsohma1@gmail.com                     ######
##################################################################

function checkLogin($loadForum = false)
{
    global $COMMON;
    
    //  check user data
    if ((Filter(@$_SESSION['user_id']) === "") && (Filter(@$_SESSION['user_name']) === ""))
    {
        if (isset($_POST['login']))
        {
            if ((Filter(@$_POST['username']) !== "") && (Filter(@$_POST['password'] !== "")))
            {
                $result = $COMMON->sql->query('SELECT * FROM `users` WHERE `username`="'.$_POST['username'].'"');
                if ($result)
                {
                    if ($result->num_rows() == 1)
                    {
                        $user_data = $result->fetch_assoc();
                        if (sha1(Filter($_POST['username'])) === $user_data['user_hash'])
                        {
                            $salt = generate_key();
                            if (crypt(hash("sha256", $_POST['password']), $salt) === crypt($user_data['password'], $salt))
                            {
                                $_SESSION['user_id']   = $user_data['user_id'];
                                $_SESSION['user_name'] = $user_data['username'];
                                
                                $COMMON->data = new Data();
                                $COMMON->data->usr = new User($user_data['user_id'], $user_data['username'], $user_data['user_hash'], $user_data['session_id']);
                                $COMMON->data->usr->session_id = session_id();
                                
                                if (!$COMMON->sql->query('UPDATE `users` SET `session_id`="'.$COMMON->data->usr->session_id.'" WHERE `user_id`="'.$COMMON->data->usr->id.'"'))
                                    errorMessage($COMMON->sql->error());
                            }
                            else
                            {
                                errorMessage("Supplied password does not match.");
                            }
                        }
                        else
                        {
                            errorMessage("Supplied usernames do not match.");
                        }
                    }
                    else
                    {
                        errorMessage($result->num_rows()." users found.");
                    }
                }
                else
                {
                    errorMessage($COMMON->sql->error());
                }
            }
            else
            {
                errorMessage("Requires both username and password not be empty.");
            }
        }
        else
        {            
            if ($loadForum)
            {
                loadHeaders();
                loginForum();
            }
        }
    }
    
    //  check server data
    $loadMain = false;
    if (isset($_SESSION['user_id']) && isset($_SESSION['user_id']) && (Filter(@$_SESSION['user_id']) !== "") && (Filter(@$_SESSION['user_name']) !== ""))
    {
        $u_result = $COMMON->sql->query('SELECT * FROM `users` WHERE `user_id`="'.$_SESSION['user_id'].'" AND `username`="'.$_SESSION['user_name'].'"');
        if ($u_result)
        {
            if ($u_result->num_rows() == 1)
            {
                $COMMON->data = new Data();
                
                $user_data = $u_result->fetch_assoc();
                if (sha1(Filter($_SESSION['user_name'])) === $user_data['user_hash'])
                {
                    $COMMON->data->usr = new User($user_data['user_id'], $user_data['username'], $user_data['user_hash'], $user_data['session_id']);
                    if ($COMMON->data->usr->session_id !== session_id())
                    {
                        resetLoginData();
                        errorMessage("Session ids don't match for this user.");
                        return false;
                    }
                    
                    if (!isset($_SESSION['server_id']) && !isset($_SESSION['server_name']) && (Filter(@$_SESSION['server_id']) === "") && (Filter(@$_SESSION['server_name']) === ""))
                    {
                        $s_result = $COMMON->sql->query('SELECT * FROM `servers` WHERE `owner_id`="'.$COMMON->data->usr->id.'"');
                        if ($s_result)
                        {
                            $COMMON->data->usr->servers = $s_result->num_rows();
                            
                            if ($s_result->num_rows() == 1)
                            {
                                $server_data = $s_result->fetch_assoc();
                                if (updateServerData($server_data))
                                    $loadMain = true;
                            }
                            else
                            {
                                if ($s_result->num_rows() > 1)
                                {
                                    if (isset($_POST['server_select']))
                                    {
                                        $s_result = $COMMON->sql->query('SELECT * FROM `servers` WHERE `server_id`="'.@$_POST['server'].'" AND `owner_id`="'.$COMMON->data->usr->id.'"');
                                        if ($s_result)
                                        {
                                            $server_data = $s_result->fetch_assoc();
                                            if (updateServerData($server_data))
                                                $loadMain = true;
                                        }
                                        else
                                        {
                                            errorMessage($COMMON->sql->error());
                                        }
                                    }
                                    else
                                    {
                                        if ($loadForum)
                                        {
                                            loadHeaders();
                                            ?>
                                        <form action="" method="post">
                                            <center>
                                                <table class="form_area">
                                                    <tr>
                                                        <td align="left" style="vertical-align: top;">
                                                            <span style="text-align: center;"><b>Server Selection</b></span>
                                                            <br />
                                            <?php
                                            while ($server_row = $s_result->fetch_assoc())
                                            {
                                            ?>
                                            <input type="radio" name="server" value="<?php echo $server_row['server_id']; ?>" /><?php echo $server_row['server_name']; ?>
                                            <br />
                                                <?php
                                            }
                                            ?>
                                                            <input type="submit" name="server_select" value="Select" style="width: 100%; padding: 5px;" />
                                                        </td>
                                                    </tr>
                                                </table>
                                            </center>
                                        </form>
                                            <?php
                                            footer();
                                        }
                                    }
                                }
                                else
                                {
                                    errorMessage("There were no servers found for this user.");
                                    resetLoginData();
                                }
                            }
                        }
                        else
                        {
                            errorMessage($COMMON->sql->error());
                        }
                    }
                    else
                    {
                        $s_result = $COMMON->sql->query('SELECT * FROM `servers` WHERE `owner_id`="'.$COMMON->data->usr->id.'"');
                        if ($s_result)
                        {
                            $COMMON->data->usr->servers = $s_result->num_rows();
                        }
                        else
                        {
                            errorMessage($COMMON->sql->error(), false, true);
                        }
                        
                        $s_result = $COMMON->sql->query('SELECT * FROM `servers` WHERE `owner_id`="'.$COMMON->data->usr->id.'" AND `server_id`="'.$_SESSION['server_id'].'"');
                        if ($s_result)
                        {
                            $server_data = $s_result->fetch_assoc();
                            updateServerData($server_data, false, true);
                            
                            $loadMain = true;
                        }
                        else
                        {
                            errorMessage($COMMON->sql->error());
                        }
                    }
                }
                else
                {
                    if ($loadForum)
                    {
                        loadHeaders();
                        errorMessage("Usernames don't match...", false);
                        resetLoginData();
                        loginForum();
                    }
                }
            }
            else
            {
                if ($loadForum)
                {
                    loadHeaders();
                    errorMessage($u_result->num_rows()." users found.", false);
                    resetLoginData();
                    loginForum();
                }
            }
        }
        else
        {
            errorMessage(mysql_error($COMMON->sql), false, true);
        }
    }
    
    return $loadMain;
}

function resetLoginData()
{
    global $COMMON;
    
    if (isset($_SESSION['user_id']))
        unset($_SESSION['user_id']);
    
    if (isset($_SESSION['user_name']))
        unset($_SESSION['user_name']);
    
    if (isset($_SESSION['server_id']))
        unset($_SESSION['server_id']);
    
    if (isset($_SESSION['server_name']))
        unset($_SESSION['server_name']);
}

function loginForum()
{
    global $COMMON;
    ?>
        <form action="" method="post">
            <center>
                <table class="form_area">
                    <tr>
                        <td align="center" style="vertical-align: top;">
                            <span style="text-align: center;"><b>User Login</b></span>
                            <center>
                                <div style="padding: 5px 5px 5px 5px; float: left;">
                                    Username: <input type="text" name="username" size="50%" />
                                </div>
                                <br />
                                <div style="padding: 5px; float: left;">
                                    Password: <input type="password" name="password" size="50%" />
                                </div>
                                <br />
                            </center>
                            <input type="submit" name="login" value="Login" style="width: 100%; padding: 5px;" />
                        </td>
                    </tr>
                </table>
            </center>
        </form>
    <?php
    footer();
}

function logout()
{
    global $COMMON;
    
    resetLoginData();
    
    header("Location: ".$COMMON->url."?area=home");
}

function generate_key()
{
    //  generate salt value
    $saltValue = "";
    for ($i = 15; $i >= 0; $i--)
        $saltValue .= rand(0, 256);
    
    $str = "";
    for($i = 0; $i < 16; $i++)
    {
        $c = intval($saltValue[$i]);
        $str .= dechex('0'.$c);
    }
    
    return $str;
}
?>